from typing import Final


# ====== CA: Common Attribute ======

class CA:
    All: Final[str] = "all"
    Api: Final[str] = "api"
    Auth: Final[str] = "aut"
    Ascending: Final[str] = "asc"  # in SQL

    Book: Final[str] = "b"
    BookChapterVersionComboId: Final[str] = "bcvcid"
    BookHeadVersionId: Final[str] = "bhvid"
    BookId: Final[str] = "bid"
    Bookkeeping: Final[str] = "bk"
    BookkeepingId: Final[str] = "bkid"
    BookList: Final[str] = "bl"
    BookListId: Final[str] = "blid"
    BookVersion: Final[str] = "bv"
    BookVersionId: Final[str] = "bvid"
    BookVersionNo: Final[str] = "bvno"

    Check: Final[str] = "chk"
    Chapter: Final[str] = "c"
    ChapterId: Final[str] = "cid"
    ChapterBoneId: Final[str] = "cbnid"
    ChapterBoneWordId: Final[str] = "cbnwid"
    ChapterHeadVersionId: Final[str] = "chvid"
    ChapterVersion: Final[str] = "cv"
    ChapterVersionId: Final[str] = "cvid"
    ChapterVersionNo: Final[str] = "cvno"
    ChapterWordId: Final[str] = "cwid"
    Click: Final[str] = "clk"
    Code: Final[str] = "cd"
    Collect: Final[str] = "clt"
    Collected: Final[str] = "cltd"
    Color: Final[str] = "col"
    Count: Final[str] = "cnt"
    Create: Final[str] = "ct"
    CreateTime: Final[str] = "crt"

    Data: Final[str] = "dt"
    Database: Final[str] = "db"
    Details: Final[str] = "dts"
    Descending: Final[str] = "desc"  # in SQL
    Description: Final[str] = "des"
    DescriptionFormatted: Final[str] = "desf"
    DescriptionId: Final[str] = "desid"
    DescriptionPlain: Final[str] = "desp"

    Empty: Final[str] = "ety"
    End: Final[str] = "ed"

    Field: Final[str] = "fid"
    Finished: Final[str] = "fied"
    FinishedWord: Final[str] = "fw"
    First: Final[str] = "fst"
    Focus: Final[str] = "fcs"
    Focusing: Final[str] = "fcsg"
    Footer: Final[str] = "ftr"
    Formatted: Final[str] = "fmt"
    FrontEnd: Final[str] = "fe"

    Grid: Final[str] = "gd"
    Group: Final[str] = "gp"

    Head: Final[str] = "hd"
    Header: Final[str] = "hdr"
    HeadVersion: Final[str] = "hv"
    Height: Final[str] = "ht"
    History: Final[str] = "hy"
    HttpStatus: Final[str] = "hts"

    Id: Final[str] = "id"
    Info: Final[str] = "inf"
    Init: Final[str] = "it"
    Item: Final[str] = "im"
    ItemPerPage: Final[str] = "impp"

    Learner: Final[str] = "lr"
    LearnerId: Final[str] = "lrid"
    List: Final[str] = "lt"
    ListWordId: Final[str] = "ltwid"
    Login: Final[str] = "lgn"

    Main: Final[str] = "main"
    Message: Final[str] = "msg"
    Mentor: Final[str] = "mr"
    MentorId: Final[str] = "mrid"

    Name: Final[str] = "na"
    NextBookVersion: Final[str] = "nbkv"
    Note: Final[str] = "nt"

    Ok: Final[str] = "ok"
    OrderRank: Final[str] = "odr"

    Page: Final[str] = "pg"
    Parameter: Final[str] = "pm"
    Password: Final[str] = "pw"
    Plain: Final[str] = "pn"
    Private: Final[str] = "pvt"
    Public: Final[str] = "pb"

    Query: Final[str] = "qy"
    Quest: Final[str] = "qt"

    Read: Final[str] = "rd"
    Request: Final[str] = "req"
    Response: Final[str] = "rsp"
    Result: Final[str] = "ret"
    Role: Final[str] = "rol"
    Rotation: Final[str] = "rot"

    Scale: Final[str] = "scl"
    Search: Final[str] = "sch"
    Sentence: Final[str] = "sn"
    SentenceAudio: Final[str] = "sa"
    SentenceAudioId: Final[str] = "said"
    SentenceId: Final[str] = "snid"
    Series: Final[str] = "ses"
    Signup: Final[str] = "sgu"
    Size: Final[str] = "siz"
    SortBy: Final[str] = "stby"
    SortDirection: Final[str] = "stdr"
    Stars: Final[str] = "strs"
    Start: Final[str] = "str"
    State: Final[str] = "ste"
    Status: Final[str] = "sts"

    Text: Final[str] = "txt"
    Time: Final[str] = "tm"
    TimeNow: Final[str] = "tnw"
    TimeZone: Final[str] = "tmz"
    Title: Final[str] = "tt"
    TitleId: Final[str] = "ttid"
    TotalSec: Final[str] = "tls"
    TotalCount: Final[str] = "tcnt"
    Transform: Final[str] = "tsf"
    Type: Final[str] = "tp"

    Update: Final[str] = "ud"
    UpdateTime: Final[str] = "udt"
    Used: Final[str] = "used"
    User: Final[str] = "usr"
    UserId: Final[str] = "uid"
    Util: Final[str] = "util"

    Version: Final[str] = "vn"
    VersionNo: Final[str] = "vno"
    VersionCreate: Final[str] = "vct"
    VersionId: Final[str] = "vid"
    Visited: Final[str] = "vst"
    Visiting: Final[str] = "vstng"

    Width: Final[str] = "wh"
    WfMedian: Final[str] = "wfm"
    Word: Final[str] = "w"
    WordBookLibrary: Final[str] = "wbl"
    WordFrequency: Final[str] = "wf"
    WordId: Final[str] = "wid"
    WordIdList: Final[str] = "widlst"

    ___Error___: Final[str] = "err"
